;--------------------------------------------------------
; File Created by SDCC : FreeWare ANSI-C Compiler
; Version 2.4.0 Fri Mar 07 01:36:04 2008

;--------------------------------------------------------
	.module FREQ1
	.optsdcc -mmcs51 --model-small
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _DispPos
	.globl _Bin2Seg
	.globl _main
	.globl _InitTimers
	.globl _Timer1_ISR
	.globl _Timer0_ISR
	.globl _FreqCntRdy
	.globl _FreqCnt
	.globl _DispNum
	.globl _DispVal
	.globl _Timer1_Cnt
	.globl _Timer0_Cnt
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
_P0	=	0x0080
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PCON	=	0x0087
_TCON	=	0x0088
_TMOD	=	0x0089
_TL0	=	0x008a
_TL1	=	0x008b
_TH0	=	0x008c
_TH1	=	0x008d
_P1	=	0x0090
_SCON	=	0x0098
_SBUF	=	0x0099
_P2	=	0x00a0
_IE	=	0x00a8
_P3	=	0x00b0
_IP	=	0x00b8
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
;--------------------------------------------------------
; special function bits 
;--------------------------------------------------------
_P0_0	=	0x0080
_P0_1	=	0x0081
_P0_2	=	0x0082
_P0_3	=	0x0083
_P0_4	=	0x0084
_P0_5	=	0x0085
_P0_6	=	0x0086
_P0_7	=	0x0087
_IT0	=	0x0088
_IE0	=	0x0089
_IT1	=	0x008a
_IE1	=	0x008b
_TR0	=	0x008c
_TF0	=	0x008d
_TR1	=	0x008e
_TF1	=	0x008f
_P1_0	=	0x0090
_P1_1	=	0x0091
_P1_2	=	0x0092
_P1_3	=	0x0093
_P1_4	=	0x0094
_P1_5	=	0x0095
_P1_6	=	0x0096
_P1_7	=	0x0097
_RI	=	0x0098
_TI	=	0x0099
_RB8	=	0x009a
_TB8	=	0x009b
_REN	=	0x009c
_SM2	=	0x009d
_SM1	=	0x009e
_SM0	=	0x009f
_P2_0	=	0x00a0
_P2_1	=	0x00a1
_P2_2	=	0x00a2
_P2_3	=	0x00a3
_P2_4	=	0x00a4
_P2_5	=	0x00a5
_P2_6	=	0x00a6
_P2_7	=	0x00a7
_EX0	=	0x00a8
_ET0	=	0x00a9
_EX1	=	0x00aa
_ET1	=	0x00ab
_ES	=	0x00ac
_EA	=	0x00af
_P3_0	=	0x00b0
_P3_1	=	0x00b1
_P3_2	=	0x00b2
_P3_3	=	0x00b3
_P3_4	=	0x00b4
_P3_5	=	0x00b5
_P3_6	=	0x00b6
_P3_7	=	0x00b7
_RXD	=	0x00b0
_TXD	=	0x00b1
_INT0	=	0x00b2
_INT1	=	0x00b3
_T0	=	0x00b4
_T1	=	0x00b5
_WR	=	0x00b6
_RD	=	0x00b7
_PX0	=	0x00b8
_PT0	=	0x00b9
_PX1	=	0x00ba
_PT1	=	0x00bb
_PS	=	0x00bc
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks 
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
_Timer0_Cnt::
	.ds 1
_Timer1_Cnt::
	.ds 1
_DispVal::
	.ds 4
_DispNum::
	.ds 1
_FreqCnt::
	.ds 2
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
	.area OSEG    (OVR,DATA)
;--------------------------------------------------------
; Stack segment in internal ram 
;--------------------------------------------------------
	.area	SSEG	(DATA)
__start__stack:
	.ds	1

;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
_FreqCntRdy::
	.ds 1
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
;--------------------------------------------------------
; interrupt vector 
;--------------------------------------------------------
	.area CSEG    (CODE)
__interrupt_vect:
	ljmp	__sdcc_gsinit_startup
	reti
	.ds	7
	ljmp	_Timer0_ISR
	.ds	5
	reti
	.ds	7
	ljmp	_Timer1_ISR
	.ds	5
	reti
	.ds	7
	reti
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
__sdcc_gsinit_startup:
	mov	sp,#__start__stack - 1
	lcall	__sdcc_external_startup
	mov	a,dpl
	jz	__sdcc_init_data
	ljmp	__sdcc_program_startup
__sdcc_init_data:
	.area GSFINAL (CODE)
	ljmp	__sdcc_program_startup
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
__sdcc_program_startup:
	lcall	_main
;	return from main will lock up
	sjmp .
;------------------------------------------------------------
;Allocation info for local variables in function 'Timer0_ISR'
;------------------------------------------------------------
;------------------------------------------------------------
;FREQ1.C:113: void Timer0_ISR(void) interrupt TF0_VECTOR _naked
;	-----------------------------------------
;	 function Timer0_ISR
;	-----------------------------------------
_Timer0_ISR:
;	naked function: no prologue.
;FREQ1.C:116: ++Timer0_Cnt;
;     genPlus
;     genPlusIncr
	inc	_Timer0_Cnt
;FREQ1.C:118: _asm	reti  _endasm;
;     genInline
	 reti 
00101$:
;	naked function: no epilogue.
;------------------------------------------------------------
;Allocation info for local variables in function 'Timer1_ISR'
;------------------------------------------------------------
;i                         Allocated to registers r2 
;------------------------------------------------------------
;FREQ1.C:127: void Timer1_ISR(void) interrupt TF1_VECTOR 
;	-----------------------------------------
;	 function Timer1_ISR
;	-----------------------------------------
_Timer1_ISR:
	ar2 = 0x02
	ar3 = 0x03
	ar4 = 0x04
	ar5 = 0x05
	ar6 = 0x06
	ar7 = 0x07
	ar0 = 0x00
	ar1 = 0x01
	push	acc
	push	b
	push	dpl
	push	dph
	push	ar2
	push	ar3
	push	ar4
	push	ar5
	push	ar6
	push	ar7
	push	ar0
	push	ar1
	push	psw
	mov	psw,#0x00
;FREQ1.C:132: TR1= 0;
;     genAssign
	clr	_TR1
;FREQ1.C:133: TH1= (byte)((TIMER1_TIME)>>8);
;     genAssign
	mov	_TH1,#0xFC
;FREQ1.C:134: TL1= (byte)(TIMER1_TIME);
;     genAssign
	mov	_TL1,#0x3F
;FREQ1.C:135: TR1= 1;
;     genAssign
	setb	_TR1
;FREQ1.C:140: ++Timer1_Cnt;
;     genPlus
;     genPlusIncr
	inc	_Timer1_Cnt
;FREQ1.C:141: if(Timer1_Cnt>=100) {
;     genCmpLt
;     genCmp
	clr	c
	mov	a,_Timer1_Cnt
	subb	a,#0x64
;     genIfxJump
;       Peephole 112.b  changed ljmp to sjmp
;       Peephole 160    removed sjmp by inverse jump logic
	jc      00102$
00112$:
;FREQ1.C:142: Timer1_Cnt=0;
;     genAssign
	mov	_Timer1_Cnt,#0x00
;FREQ1.C:144: TR0= 0; 
;     genAssign
	clr	_TR0
;FREQ1.C:145: FreqCnt= (((dword)TH0)<<8) | ((dword)TL0) ;   // f/16
;     genCast
	mov	r2,_TH0
	mov	r3,#0x00
	mov	r4,#0x00
	mov	r5,#0x00
;     genLeftShift
;     genLeftShiftLiteral
;     genlshFour
	mov	ar5,r4
	mov	ar4,r3
	mov	ar3,r2
	mov	r2,#0x00
;     genCast
	mov	r6,_TL0
	mov	r7,#0x00
;     genOr
;       Peephole 3.c    changed mov to clr
	clr     a
	mov     r0,a
	mov     r1,a
	mov     a,r6
	orl	ar2,a
	mov	a,r7
	orl	ar3,a
	mov	a,r0
	orl	ar4,a
	mov	a,r1
	orl	ar5,a
;     genCast
	mov	_FreqCnt,r2
	mov	(_FreqCnt + 1),r3
;FREQ1.C:146: TH0= 0;
;     genAssign
	mov	_TH0,#0x00
;FREQ1.C:147: TL0= 0;
;     genAssign
	mov	_TL0,#0x00
;FREQ1.C:148: TR0= 1; 
;     genAssign
	setb	_TR0
;FREQ1.C:149: FreqCntRdy=1;
;     genAssign
	setb	_FreqCntRdy
00102$:
;FREQ1.C:155: i = Bin2Seg[DispVal[DispNum]]; 
;     genPlus
	mov	a,_DispNum
	add	a,#_DispVal
	mov	r0,a
;     genPointerGet
;     genNearPointerGet
	mov	ar2,@r0
;     genPlus
;       Peephole 236.g  used r2 instead of ar2
	mov     a,r2
;       Peephole 181    changed mov to clr
;     genPointerGet
;     genCodePointerGet
;       Peephole 181    changed mov to clr
;       Peephole 186.d  optimized movc sequence
	mov     dptr,#_Bin2Seg
	movc    a,@a+dptr
	mov	r2,a
;FREQ1.C:156: if(DispNum==3) i |= DecimalPoint; /* decimal points fixed on 3 position ( "3.500")*/
;     genCmpEq
	mov	a,_DispNum
;       Peephole 112.b  changed ljmp to sjmp
;       Peephole 199    optimized misc jump sequence
	cjne    a,#0x03,00104$
;00113$:
;       Peephole 200    removed redundant sjmp
00114$:
;     genOr
	orl	ar2,#0x04
00104$:
;FREQ1.C:157: P3 = 0xff; /* all diplays off*/
;     genAssign
	mov	_P3,#0xFF
;FREQ1.C:158: P1 = ~i;
;     genCpl
	mov	a,r2
	cpl	a
	mov	_P1,a
;FREQ1.C:159: P3= DispPos[DispNum];
;     genPlus
	mov	a,_DispNum
;       Peephole 181    changed mov to clr
;     genPointerGet
;     genCodePointerGet
;       Peephole 181    changed mov to clr
;       Peephole 186.d  optimized movc sequence
	mov     dptr,#_DispPos
	movc    a,@a+dptr
	mov	_P3,a
;FREQ1.C:160: if(++DispNum>=MAXDISPNUM) DispNum=0;
;     genPlus
;     genPlusIncr
	inc	_DispNum
;     genCmpLt
;     genCmp
	clr	c
	mov	a,_DispNum
	subb	a,#0x04
;     genIfxJump
;       Peephole 112.b  changed ljmp to sjmp
;       Peephole 160    removed sjmp by inverse jump logic
	jc      00107$
00115$:
;     genAssign
	mov	_DispNum,#0x00
00107$:
	pop	psw
	pop	ar1
	pop	ar0
	pop	ar7
	pop	ar6
	pop	ar5
	pop	ar4
	pop	ar3
	pop	ar2
	pop	dph
	pop	dpl
	pop	b
	pop	acc
	reti
;------------------------------------------------------------
;Allocation info for local variables in function 'InitTimers'
;------------------------------------------------------------
;------------------------------------------------------------
;FREQ1.C:167: void InitTimers(void)
;	-----------------------------------------
;	 function InitTimers
;	-----------------------------------------
_InitTimers:
;FREQ1.C:169: Timer0_Cnt=0;
;     genAssign
	mov	_Timer0_Cnt,#0x00
;FREQ1.C:170: Timer1_Cnt=0;
;     genAssign
;FREQ1.C:171: FreqCnt=0;
;     genAssign
;       Peephole 3.b    changed mov to clr
	clr     a
	mov     _Timer1_Cnt,a
	mov	(_FreqCnt + 1),a
	mov	_FreqCnt,a
;FREQ1.C:172: FreqCntRdy=0;
;     genAssign
	clr	_FreqCntRdy
;FREQ1.C:175: TCON=0;
;     genAssign
	mov	_TCON,#0x00
;FREQ1.C:177: TMOD = 0x15; /* 00010101*/
;     genAssign
	mov	_TMOD,#0x15
;FREQ1.C:178: TH1 = (byte)((TIMER1_TIME)>>8);
;     genAssign
	mov	_TH1,#0xFC
;FREQ1.C:179: TL1 = (byte)(TIMER1_TIME);
;     genAssign
	mov	_TL1,#0x3F
;FREQ1.C:180: TH0=0;
;     genAssign
	mov	_TH0,#0x00
;FREQ1.C:181: TL0=0;
;     genAssign
	mov	_TL0,#0x00
;FREQ1.C:183: TCON = 0x50; /* 01010000  */
;     genAssign
	mov	_TCON,#0x50
;FREQ1.C:185: IE=0x88; /* 10001000 Timer1 overflow interrupt enabled*/
;     genAssign
	mov	_IE,#0x88
00101$:
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'main'
;------------------------------------------------------------
;i                         Allocated to registers 
;xx                        Allocated to registers r2 r3 r4 r5 
;yy                        Allocated to registers r2 r3 
;------------------------------------------------------------
;FREQ1.C:195: void main(void)
;	-----------------------------------------
;	 function main
;	-----------------------------------------
_main:
;FREQ1.C:208: IP=0;
;     genAssign
	mov	_IP,#0x00
;FREQ1.C:210: InitTimers();
;     genCall
	lcall	_InitTimers
00108$:
;FREQ1.C:214: if(FreqCntRdy) {
;     genIfx
;     genIfxJump
;       Peephole 111    removed ljmp by inverse jump logic
;FREQ1.C:215: FreqCntRdy=0;
;     genAssign
;       Peephole 250.a  using atomic test and clear
	jbc     _FreqCntRdy,00116$
	sjmp    00108$
00116$:
;FREQ1.C:217: xx = FreqCnt;
;     genCast
	mov	r2,_FreqCnt
	mov	r3,(_FreqCnt + 1)
;FREQ1.C:218: xx <<= 5;
;     genLeftShift
;     genLeftShiftLiteral
;     genlshFour
;       Peephole 3.c    changed mov to clr
	clr     a
	mov     r4,a
;       Peephole 105    removed redundant mov
	mov     r5,a
	swap	a
	rl	a
	anl	a,#0xe0
	xch	a,r4
	swap	a
	rl	a
	xch	a,r4
	xrl	a,r4
	xch	a,r4
	anl	a,#0xe0
	xch	a,r4
	xrl	a,r4
	mov	r5,a
	mov	a,r3
	swap	a
	rl	a
	anl	a,#0x1f
	orl	a,r4
	mov	r4,a
	mov	a,r3
	swap	a
	rl	a
	anl	a,#0xe0
	xch	a,r2
	swap	a
	rl	a
	xch	a,r2
	xrl	a,r2
	xch	a,r2
	anl	a,#0xe0
	xch	a,r2
	xrl	a,r2
	mov	r3,a
;FREQ1.C:219: xx /= 100L;
;     genAssign
	clr	a
	mov	(__divulong_PARM_2 + 3),a
	mov	(__divulong_PARM_2 + 2),a
	mov	(__divulong_PARM_2 + 1),a
	mov	__divulong_PARM_2,#0x64
;     genCall
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	mov	a,r5
	lcall	__divulong
	mov	r2,dpl
	mov	r3,dph
	mov	r4,b
	mov	r5,a
;FREQ1.C:220: yy = IF_FREQ - (xx - 4);
;     genMinus
;     genMinusDec
	mov	a,r2
	add	a,#0xfc
	mov	r2,a
	mov	a,r3
	addc	a,#0xff
	mov	r3,a
	mov	a,r4
	addc	a,#0xff
	mov	r4,a
	mov	a,r5
	addc	a,#0xff
	mov	r5,a
;     genMinus
	mov	a,#0x40
	clr	c
;       Peephole 236.l  used r2 instead of ar2
	subb    a,r2
	mov	r2,a
	mov	a,#0x1F
;       Peephole 236.l  used r3 instead of ar3
	subb    a,r3
	mov	r3,a
;       Peephole 181    changed mov to clr
	clr     a
;       Peephole 236.l  used r4 instead of ar4
	subb    a,r4
	mov	r4,a
;       Peephole 181    changed mov to clr
	clr     a
;       Peephole 236.l  used r5 instead of ar5
	subb    a,r5
	mov	r5,a
;     genCast
;FREQ1.C:222: for(i=0; i<MAXDISPNUM; ++i) {
;     genAssign
	mov	r4,#0x00
00103$:
;     genCmpLt
;     genCmp
	cjne	r4,#0x04,00117$
00117$:
;     genIfxJump
;       Peephole 108    removed ljmp by inverse jump logic
	jnc     00106$
00118$:
;FREQ1.C:223: DispVal[i] = yy%10;
;     genPlus
;       Peephole 236.g  used r4 instead of ar4
	mov     a,r4
	add	a,#_DispVal
	mov	r0,a
;     genAssign
	clr	a
	mov	(__moduint_PARM_2 + 1),a
	mov	__moduint_PARM_2,#0x0A
;     genCall
	mov	dpl,r2
	mov	dph,r3
	push	ar2
	push	ar3
	push	ar4
	push	ar0
	lcall	__moduint
	mov	r5,dpl
	mov	r6,dph
	pop	ar0
	pop	ar4
	pop	ar3
	pop	ar2
;     genCast
;     genPointerSet
;     genNearPointerSet
	mov	@r0,ar5
;FREQ1.C:224: yy /= 10;
;     genAssign
	clr	a
	mov	(__divuint_PARM_2 + 1),a
	mov	__divuint_PARM_2,#0x0A
;     genCall
	mov	dpl,r2
	mov	dph,r3
	push	ar4
	lcall	__divuint
	mov	r2,dpl
	mov	r3,dph
	pop	ar4
;FREQ1.C:222: for(i=0; i<MAXDISPNUM; ++i) {
;     genPlus
;     genPlusIncr
	inc	r4
;       Peephole 112.b  changed ljmp to sjmp
	sjmp    00103$
00106$:
;FREQ1.C:227: InitTimers();
;     genCall
	lcall	_InitTimers
	ljmp	00108$
00110$:
	ret
	.area CSEG    (CODE)
_Bin2Seg:
	.db #0x7B
	.db #0x42
	.db #0xD9
	.db #0xD3
	.db #0xE2
	.db #0xB3
	.db #0xBB
	.db #0x52
	.db #0xFB
	.db #0xF3
	.db #0xFA
	.db #0xAB
	.db #0x39
	.db #0xCB
	.db #0xB9
	.db #0x00
_DispPos:
	.db #0xFE
	.db #0xFD
	.db #0xFB
	.db #0xF7
